%Processing the data for A/D, STD(A/D), and Vibration Frequency
%Run==> Select file ==>  result
%It should combine the peakdet.m file together
%By Hai Sun, July 1st,2014

close all
clear
%clc
%Reading the ticks for amplitude


[FileName, PathName]=uigetfile({'*.csv';'*.dat'},'Select data');
fileID = fopen([PathName FileName]);
data=textscan(fileID, '%f %f %f %f %f', 'delimiter', ',');
disp(FileName)
fclose(fileID);


PositionTicks=data{1};
Mean=mean(PositionTicks);
PositionTicks=PositionTicks - Mean;

% A/D
AoverD=PositionTicks.*0.9144./22684./0.0889;
ticks=numel(AoverD);
tMax=0.005*ticks;tMiddle=tMax/ticks;t=0.005:tMiddle:tMax;t=t';
% find the max and min amplitude in A/D
figure; plot(t,AoverD);
[maxtab, mintab] = peakdet(AoverD, 0.5, t);
lastMax=length(maxtab)-1;
lastMin=length(mintab)-1;
%delete the first and last max and min
maxtab = maxtab( 2:lastMax , : );
mintab = mintab( 2:lastMin , : );
hold on; plot(mintab(:,1), mintab(:,2), 'g*');
plot(maxtab(:,1), maxtab(:,2), 'r*');
xlabel('Time/s')
ylabel('A/D')

%find the A/D by plus the max and min over 2
Max=sort(maxtab(:,2),'descend');
Min=sort(mintab(:,2),'descend');
max30=Max(1:10);
min30=Min(1:10);
meanMax=mean(max30);
meanMin=mean(min30);
Amplitude=(abs(meanMax)+abs(meanMin))/2;


STDmax=std(max30);
STDmin=std(min30);
STD=(STDmax+STDmin)/2;

%calculate the frequency
tempMax=maxtab(:,1)';
tempMin=mintab(:,1)';
timeIntervalMax=tempMax(lastMax-1)-tempMax(1);
timeIntervalMin=tempMin(lastMin-1)-tempMin(1);
Frequency = ((lastMax/timeIntervalMax)+(lastMin/timeIntervalMin))/2;
disp('     A/D        STD     Frequency')
disp([Amplitude STD Frequency])
