clc
clear all

%coded by KAI LAN for MRELab, on August,2016, Ann Arbor
% maximum file number this program can deal with is 25, do not exceed

%set the natural frequency in water, and the dividing value to adjust magnitude of FFT magnitude 
 fnwater = 0.834;                 % CHANGE THE VALUE DUE TO DIFFERENT SITUATION!
 dividingvalue = 12000000;        % CHANGE THE VALUE DUE TO PRICTICAL SITUATION!
 
 
% read files 
  [filename, pathname] = uigetfile({'*.csv';'*.dat'},[ 'displacement-time history data file(s)'],'MultiSelect', 'on');
  filesnumber = length(filename);
 

   if isequal(filename, 0)
      error('User selected Cancel') %when no data is selected
   else %when user selects tick data files to be processed

 % convert filenames to a cell array of strings
    if ~iscellstr(filename), filename = cellstr(filename); end     
    disp(['User selected the following file(s):']);
    fprintf('%s\n', filename{:});
   end
   
   %establish the order for writing results to excel (line 53)
   orderexcel = ['B1';'C1';'D1';'E1';'F1';'G1';'H1';'I1';'J1';'K1';'L1';'M1';'N1';'O1';'P1';'Q1';'R1';'S1';'T1';'U1';'V1';'W1';'X1';'Y1';'Z1'];
   
   
   for k = 1:filesnumber 
     disp(k);
     % locate the flowspeed from the file name
     filenamestring = char(filename(k));
     stringlength = length(filenamestring);
     
     flowspeed = filenamestring((stringlength-5):(stringlength-4));
     flowspeednumber = str2num(flowspeed);

     % extract the data from selected file
     readingdata = csvread(filenamestring);
     timepositiondata = readingdata(:,1);
 
     % FFT
     fs=200;N=12000;   
     n=0:N-1;t=n/fs; 
     f = n*fs/N; 
     y=fft(timepositiondata,N); 
     
     
     %calculate the magnitude of FFT results. we only need the range of 
     %f = 0~3.
    
     
     mag = abs(y);
     magpart = mag(3:181);
     ftrans = f';
     ftranspart = ftrans(3:181);
     magpart2 = magpart/dividingvalue;

     % establish the U*
    
     ustar = (flowspeednumber * 0.02-0.0054);
     magpart3 = magpart2./16 + ustar;
     
     % write to excel
     excelposition = orderexcel(k,:);
     xlswrite('FFTresults.xls',ftranspart,1,'A1');
     xlswrite('FFTresults.xls',magpart3,1,excelposition);
     k=k+1;
   end